QOF: Choice: One to many links.

QOF 0.7.5

Files | Macros
Choice: One to many links.
Query Object Framework

## Files
file | qofchoice.h
| Linking one entity to other entities of many possible types.

## Macros
#define | QOF_MOD_CHOICE "qof-choice"
gboolean | qof_object_is_choice (QofIdType type)
| Does this object contain a choice parameter? More...
gboolean | qof_choice_create (gchar *type)
| Set an object as using QOF_TYPE_CHOICE.
gboolean | qof_choice_add_class (gchar *choice, gchar *add, gchar *param_name)
| Add the choices for this parameter to the object. More...
GList * | qof_object_get_choices (QofIdType type, QofParam *param)
| Return the list of all object types usable with this parameter. More...
gboolean | qof_choice_check (gchar *choice_obj, gchar *param_name, gchar *choice)
| Is the choice valid for this param_name? More...
#define | QOF_TYPE_CHOICE "choice"
| Identify an object as containing a choice. More...

## Detailed Description

Objects can be linked together one-to-one by simply using the name of the related object as the parameter type in the QofClass parameter list.

    { FOO_PARAM, BAR_ID, (QofAccessFunc)qofFooGetBar, (QofSetterFunc)qofFooSetBar },

This is limited as each FOO entity can contain only one reference to a single BAR entity per parameter. Also, this parameter cannot be used to link to a similar object, OBJ. This requires "one to many" links.

There are two types of one-to-many links in QOF.

1. QOF_TYPE_COLLECT - one to many entities all of only one type.
   - Handles links between one object and a series of objects that are all of the same type, e.g. a simple list.
2. QOF_TYPE_CHOICE - one to a single entity of many possible types.
   - Handles links between one object and a series of dissimilar objects, one of each type.

Currently, there is no explicit way to support many-to-many links but existing methods can be combined to give approximately the same results.

A QOF_TYPE_CHOICE object is like a C++ template. QOF_TYPE_CHOICE doesn't really exist by itself:

    QOF_TYPE_CHOICE<QOF_X, QOF_Y, QOF_Z>

It holds a single entity of type X, Y, or Z for the purposes of QOF or ::QSF. For querying the object it queries as if it's an X, Y, or Z.

Each choice type has it's own definition of the allowable objects - each of which need to be registered as normal. Objects can declare themselves to be one option of a particular choice. There is no requirement for any object to be either a choice or an option for a choice object.

1. Each QOF_TYPE_CHOICE parameter provides access to ONE entity of a pre-determined set of object types.
2. The entity type within the choice can be determined at run time.
3. Each entity can have a different type of entity to it's siblings, provided that it is one of the pre-determined object types.
4. Objects declare themselves as containing choices and other objects can add themselves to the list of acceptable choices of suitable objects.
5. QOF_TYPE_CHOICE is transparent - objects should retrieve the e_type of the received entity and handle the entity appropriately.
6. The number of different entity types that can be pre-determined for any one QOF_TYPE_CHOICE parameter is not fixed. You can have as many types as the QofAccessFunc and QofSetterFunc can handle.
7. Any one parameter can only have one QOF type. You cannot have a parameter that is both QOF_TYPE_COLLECT and QOF_TYPE_CHOICE any more than you can have one parameter that is both ::QOF_TYPE_BOOLEAN and ::QOF_TYPE_NUMERIC.
8. When setting references using QOF_TYPE_CHOICE, QOF passes a single entity to the QofSetterFunc and it is left to the function to determine how to handle that entity type. When retrieving references using QOF_TYPE_CHOICE, the object must return a single entity matching one of the choice types.

## Macro Definition Documentation

## ◆ QOF_TYPE_CHOICE

#define QOF_TYPE_CHOICE "choice"

Identify an object as containing a choice.

Note
  Choice

Definition at line 103 of file qofchoice.h.

## Function Documentation

## ◆ qof_choice_add_class()

gboolean qof_choice_add_class | ( | gchar * | choice,
|  | gchar * | add,
|  | gchar * | param_name
| ) |  |

Add the choices for this parameter to the object.

Parameters

  choice | The choice object.
  add | The object to be added as an option.
  param_name | The parameter that will be used to get or set options.

Returns
  FALSE if object is not a choice object or on error otherwise TRUE.

Definition at line 75 of file qofchoice.c.

76 {
77 GHashTable *param_table;
78 GList *option_list;
79
80 option_list = NULL;
81 param_table = NULL;
82 g_return_val_if_fail (select != NULL, FALSE);
83 g_return_val_if_fail (qof_object_is_choice (select), FALSE);
84 param_table =
85 (GHashTable *) g_hash_table_lookup (qof_choice_table, select);
86 g_return_val_if_fail (param_table, FALSE);
87 option_list = (GList *) g_hash_table_lookup (param_table, param_name);
88 option_list = g_list_append (option_list, option);
89 g_hash_table_insert (param_table, param_name, option_list);
90 return TRUE;
91 }
qof_object_is_choice
gboolean qof_object_is_choice(QofIdType type)
Does this object contain a choice parameter?
Definition: qofchoice.c:45

## ◆ qof_choice_check()

gboolean qof_choice_check | ( | gchar * | choice_obj,
|  | gchar * | param_name,
|  | gchar * | choice
| ) |  |

Is the choice valid for this param_name?

Parameters

  choice_obj | The object containing the QOF_TYPE_CHOICE parameter.
  param_name | The name of a QOF_TYPE_CHOICE parameter in this object.
  choice | The QofIdType to look for in the list of choices.

Returns
  TRUE if choice is found in the list of allowed choices for this parameter of this object. Otherwise, FALSE

Definition at line 108 of file qofchoice.c.

109 {
110 GList *choices, *result;
111 GHashTable *param_table;
112
113 choices = result = NULL;
114 g_return_val_if_fail (qof_object_is_choice (choice_obj), FALSE);
115 param_table = g_hash_table_lookup (qof_choice_table, choice_obj);
116 choices = g_hash_table_lookup (param_table, param_name);
117 result = g_list_find (choices, choice);
118 if (!result)
119 return FALSE;
120 return TRUE;
121 }
qof_object_is_choice
gboolean qof_object_is_choice(QofIdType type)
Does this object contain a choice parameter?
Definition: qofchoice.c:45

## ◆ qof_object_get_choices()

GList* qof_object_get_choices | ( | QofIdType | type,
|  | QofParam * | param
| ) |  |

Return the list of all object types usable with this parameter.

Parameters

  type | The choice object type.
  param | The name of the parameter that will be used to get or set options.

Returns
  NULL on error or if no options exist for this parameter, otherwise a GList of all QofIdType object type(s) available via this choice object using this parameter.

Definition at line 94 of file qofchoice.c.

95 {
96 GList *choices;
97 GHashTable *param_table;
98
99 g_return_val_if_fail (type != NULL, NULL);
100 g_return_val_if_fail (qof_choice_is_initialized () == TRUE, FALSE);
101 choices = NULL;
102 param_table = g_hash_table_lookup (qof_choice_table, type);
103 choices = g_hash_table_lookup (param_table, param->param_name);
104 return choices;
105 }

## ◆ qof_object_is_choice()

gboolean qof_object_is_choice | ( | QofIdType | type | ) |

Does this object contain a choice parameter?

Returns TRUE if any parameter in the object definition uses a choice of elements, whether or not those parameters contain any data.

Parameters

  type | Type of object/entity.

Returns
  TRUE if one or more choice parameters has been registered using the object definition, otherwise FALSE.

Definition at line 45 of file qofchoice.c.

46 {
47 gpointer value, check;
48
49 value = NULL;
50 check = NULL;
51 if (!qof_choice_is_initialized ())
52 return FALSE;
53 g_return_val_if_fail (type != NULL, FALSE);
54 value = g_hash_table_lookup (qof_choice_table, type);
55 if ((GHashTable *) value)
56 return TRUE;
57 return FALSE;
58 }